#ifndef _FFT_H_
#define _FFT_H_

void komplexmult(double* x, double* y,double* z)
// berechnet z=x*y in C
{
  z[0]=x[0]*y[0]-x[1]*y[1];
  z[1]=x[1]*y[0]+x[0]*y[1];
}


void FFT(int k,double* x,double* y)
// berechnet mittels FFT x=F_n y mit n=2^k
// x,y: jeweils als Real+Img. hintereinander gespeichert
// d.h. Laenge 2n
{
  int n,i,m;
  double phi,pi;
  double z[2];
  double* h; 
  double* w;
  if (k>0)
    {
     n=pow(2,k);
     m=n/2;
     pi=4.0*atan(1.0);
     phi=pi/double(m);
     z[0]=cos(phi);
     z[1]=sin(phi);
     h=(double*)malloc(2*n*sizeof(double));  
     w=(double*)malloc(2*n*sizeof(double));  
     h[0]=1.;
     h[1]=0.;
     for (i=1;i<m;i++)
      {
        komplexmult(&h[2*i-2],z,&h[2*i]);
      }
     vdplus(n,x,1,&x[n],1,w,1);
     vdminus(n,x,1,&x[n],1,&w[n],1);
     for (i=0;i<m;i++)
      {
        komplexmult(&h[2*i],&w[2*i+n],&h[2*i+n]);
      }
     vdcopy(n,h,1,w,1);
     //     ausgabe(w,n);
     // vdplus(n,x,1,w,1,h,1);
     //     vdminus(n,x,1,w,1,&h[n],1);
     // ausgabe(h,2*n);
     FFT(k-1,h,w);
     FFT(k-1,&h[n],&w[n]);
     //     ausgabe(w,2*n);
     free(h);
     for (i=0;i<m;i++)
       {
	 y[4*i]=w[2*i];
         y[4*i+1]=w[2*i+1];
         y[4*i+2]=w[2*i+n];
         y[4*i+3]=w[2*i+n+1];
       }
     free(w);
     }
  else
    {
      vdcopy(2,y,1,x,1);
    }
}

#endif
